Unit AtariMnu;
{ DEFINE LOWRES}
Interface

Uses AtariDbg,Profile,_XMS,ProtMenu,TypeText;

Type
  TPF2ReadCount = Array[0..$3F] Of Byte;
  TInitSound    = Procedure;
  TSoundBuf     = Array[0..1] Of Pointer;
  ConfigRec     = Record
    UseJoystick1       : Boolean; { 0     }
    UseJoystick2       : Boolean; { 1     }
    DoSound            : Boolean; { 2     }
    MinJoyX            : Word;    { 3-4   }
    MaxJoyX            : Word;    { 5-6   }
    MinJoyY            : Word;    { 7-8   }
    MaxJoyY            : Word;    { 9-10  }
    MinJoyX2           : Word;    { 11-12 }
    MaxJoyX2           : Word;    { 13-14 }
    MinJoyY2           : Word;    { 15-16 }
    MaxJoyY2           : Word;    { 17-18 }
    FrameRate          : Word;    { 19-20 }
    SoundBufSize       : Word;    { 21-22 }
    JoyCenterX         : Word;    { 23-24 }
    JoyCenterY         : Word;    { 25-26 }
    JoyCenterX2        : Word;    { 27-28 }
    JoyCenterY2        : Word;    { 29-30 }
    PlaybackRate       : Word;    { 31-32 }
    UseRealControllers : Boolean; { 33    }
    LPT1Port           : Word;    { 34-35 }
    PaddleMax          : Word;    { 36-37 }
    MaxRows            : Byte;    { 38    }
    Player1Fire        : Byte;    { 39    }
    JoystickReset      : Byte;    { 40    }
    Player2Fire        : Byte;    { 41    }
    JoystickSelect     : Byte;    { 42    }
    MousePaddle        : Byte;    { 43    }
  End;

Function Menu(Var Config: ConfigRec; Version: String;
              Var Top,Sel: Integer;
              Var JoyMinX,JoyMaxX,JoyMinY,JoyMaxY,JoyCenterX,JoyCenterY,
                  JoyMinX2,JoyMaxX2,JoyMinY2,JoyMaxY2,JoyCenterX2,JoyCenterY2: Word;
                  Handle: XMS_XmBlk;
              Var SoundBuf: TSoundBuf;
              Var SoundBufSize,Playback_Freq,BankSize: Word;
                  InitSound: TInitSound;
                  DeAllocSound: TInitSound;
              Var Controller: TController;
              Var Debugger,DoSound,UseMenu: Boolean;
                  BankSwitch: PBankSwitch;
              Var Cart: TCart;
              Var PF2ReadCount: TPF2ReadCount;
              Var MNetworkRAM: Byte;
              Var MegaBoyNum: Word): String;

Implementation

Uses OPCrt,Dos,HexWrite;

Const
  ConfigFile     = 'PCAE.CFG';
  CRLF           = #13 + #10;

Var OldController: TController;

Procedure JoyStatus(Config: ConfigRec; Var B: Byte; Var X1,Y1,X2,Y2: Word);
{ ------------------------------------------------------------------------- }
{ Returns:                                                                  }
{    BL - JoyStatus                                                         }
{    CX - X1  SI - X2                                                       }
{    DX - Y1  DI - Y2                                                       }
{ ------------------------------------------------------------------------- }
Var
  _B              : Byte;
  _X1,_Y1,_X2,_Y2 : Word;
  Use2            : Boolean;

Begin
  Use2 := Config.UseJoystick2;
  Asm
    SUB    BX,BX
    SUB    CX,CX
    SUB    SI,SI
    SUB    DI,DI
    MOV    DX,0201h
    CLI
    SUB    AH,AH

    { Reset delays }

  @L2:
    INC    BX
    CMP    BX,8000
    JE     @L2A
    IN     AL,DX
    TEST   AL,0Fh
    JNZ    @L2
  @L2A:
    SUB    BX,BX

    OUT    DX,AL
    JMP    @L1
  @L1:
    AAA

    { Get coordinates }

  @L3:
    IN     AL,DX
    TEST   AL,1            { Player 1 X coordinate }
    JZ     @L4
    INC    BX
    CMP    BX,1000h
    JA     @L6
  @L4:
    TEST   AL,2            { Player 1 Y coordinate }
    JZ     @L5
    INC    CX
    JC     @L6
    CMP    CX,1000h
    JA     @L6
  @L5:
    IN     AL,DX
    TEST   AL,4            { Player 2 X coordinate }
    JZ     @L4A
    INC    SI
    CMP    SI,1000h
    JA     @L6
  @L4A:
    TEST   AL,8            { Player 2 Y coordinate }
    JZ     @L5A
    INC    DI
    JC     @L6
    CMP    DI,1000h
    JA     @L6
  @L5A:
    MOV    AH,0Fh
    TEST   BYTE PTR Use2,0FFh
    JNZ    @Use2
    MOV    AH,3
  @Use2:
    TEST   AL,AH
    JNZ    @L3
  @L6:
    STI
    MOV    DX,CX
    MOV    CX,BX
    MOV    BX,AX
    SUB    BH,BH
    SHR    BX,1
    SHR    BX,1
    SHR    BX,1
    SHR    BX,1
    XOR    BX,0Fh

    MOV   BYTE PTR _B,BL
    MOV   WORD PTR _X1,CX
    MOV   WORD PTR _Y1,DX
    MOV   WORD PTR _X2,SI
    MOV   WORD PTR _Y2,DI
  End;
  B  := _B;
  X1 := _X1;
  Y1 := _Y1;
  X2 := _X2;
  Y2 := _Y2;
End; { JoyStatus }


Procedure MainMenuHelp;
Begin
  TextColor(LightGray);
  TextBackGround(Blue);
  ClrScr;
  GotoXY(3,1);  Write('Run options');
  GotoXY(5,3);  Write('<Esc> ............................ Quit');
  GotoXY(5,4);  Write('Arrow keys or Joystick ........... Move selection');
  GotoXY(5,5);  Write('<Enter> or Joystick button 1 ..... Run 2K/4K/Atari 8K/Atari 16K cart');
  GotoXY(5,6);  Write('A ................................ Run Activision 16K cart');
  GotoXY(5,7);  Write('M ................................ Run M-Network 8K RAM cart');
  GotoXY(5,8);  Write('P ................................ Run Parker Bros. 8K cart');
  GotoXY(5,9);  Write('R ................................ Run Atari super-chip cart');
  GotoXY(5,10); Write('T ................................ Run TigerVision cart');
  GotoXY(5,11); Write('2 ................................ Run Pitfall II cart');
  GotoXY(3,14); Write('Game options');
  GotoXY(5,16); Write('F1 ............................... Help/status screen');
  GotoXY(5,17); Write('F2 ............................... Reset game');
  GotoXY(5,18); Write('F4 ............................... Select game');
  GotoXY(5,19); Write('F5 ............................... Color/BW switch');
  GotoXY(5,20); Write('F6/F7 ............................ Player 1/2 difficulty');
  GotoXY(5,21); Write('=,- .............................. Shift screen up or down');
  GotoXY(5,22); Write('F10 .............................. Toggle vertical autocentering');
  ReadKey;
  ClrScr;
  GotoXY(3,1);  Write('Command-line options');
  GotoXY(2,2);  Write('Use: ATARI filename [BANK|BANK16|BANKA|BANKM|BANKP|BANKC|BANKSC|BANKSP|BANKT|');
  GotoXY(2,3);  Write('                     BANK2|BANKG|BANK3|PROFILE][DEBUG][DISASM][FRAMExx][KB|');
  GotoXY(2,4);  Write('                     INDY500|VTP|PADDLE]');
  GotoXY(5,5);  Write('BANK ............................. Run Atari 8K cart');
  GotoXY(5,6);  Write('BANK16 ........................... Run Atari 16K cart');
  GotoXY(5,7);  Write('BANKA ............................ Run Activision 16K cart');
  GotoXY(5,8);  Write('BANKM ............................ Run M-Network 8K RAM cart');
  GotoXY(5,9);  Write('BANKP ............................ Run Parker Bros. 8K cart');
  GotoXY(5,10); Write('BANKC ............................ Run CBS RAM-Plus 12K cart');
  GotoXY(5,11); Write('BANKSC ........................... Run Atari super-chip cart');
  GotoXY(5,12); Write('BANKSP ........................... Run Starpath Supercharger cart');
  GotoXY(5,13); Write('BANKT ............................ Run TigerVision cart');
  GotoXY(5,14); Write('BANK2 ............................ Run Pitfall II cart');
  GotoXY(5,15); Write('BANKG ............................ Run 16-in-1 MegaBoy cart');
  GotoXY(5,16); Write('BANK3 ............................ Run Atari 32-in-1 cart');
  GotoXY(5,17); Write('32IN1NUMxx ....................... Run Atari 32-in-1 game xx (0-31)');
  GotoXY(5,18); Write('PROFILE .......................... Use game profile file');
  GotoXY(5,19); Write('DEBUG ............................ Use intregrated debugger');
  GotoXY(5,20); Write('DISASM ........................... Disassemble 4k cart to LISTING.ASM');
  GotoXY(5,21); Write('FRAMExx .......................... Limit emulation to xx frames/second');
  GotoXY(5,22); Write('KB ............................... Run Atari keyboard controller game');
  GotoXY(5,23); Write('INDY500 .......................... Emulate Indy 500 controllers');
  GotoXY(5,24); Write('VTP .............................. Emulate Video Touch Pad');
  GotoXY(5,25); Write('PADDLE ........................... Emulate Paddle controllers');
  ReadKey;
  TextColor(LightGray);
  TextBackGround(Blue);
  ClrScr;
End; { MainMenuHelp }


Function Menu(Var Config: ConfigRec; Version: String;
              Var Top,Sel: Integer;
              Var JoyMinX,JoyMaxX,JoyMinY,JoyMaxY,JoyCenterX,JoyCenterY,
                  JoyMinX2,JoyMaxX2,JoyMinY2,JoyMaxY2,JoyCenterX2,JoyCenterY2: Word;
                  Handle: XMS_XmBlk;
              Var SoundBuf: TSoundBuf;
              Var SoundBufSize,Playback_Freq,BankSize: Word;
                  InitSound: TInitSound;
                  DeAllocSound: TInitSound;
              Var Controller: TController;
              Var Debugger,DoSound,UseMenu: Boolean;
                  BankSwitch: PBankSwitch;
              Var Cart: TCart;
              Var PF2ReadCount: TPF2ReadCount;
              Var MNetworkRAM: Byte;
              Var MegaBoyNum: Word): String;
Const
  ButtonNum : Array[1..15] Of Byte = (1,2,2,3,3,3,3,4,4,4,4,4,4,4,4);
  ButtonBit : Array[1..15] Of Byte = (1,2,2,4,4,4,4,8,8,8,8,8,8,8,8);

Type
  PFileListType = ^TFileListType;
  TFileListType = Record
    Name : String[12];
    Size : LongInt;
    Next : PFileListType;
    Prev : PFileListType;
  End;

Var
  I       : Word;
  Head    : PFileListType;
  Tail    : PFileListType;
  Work    : PFileListType;
  Work1   : PFileListType;
  Temp    : TFileListType;
  S       : SearchRec;
  Ch,C    : Char;
  MaxX    : Integer;
  MaxY    : Integer;
  Cols    : Integer;
  Rows    : Integer;
  Num     : Integer;
  Show    : Boolean;
  J       : Integer;
  JoyX1   : Word;
  JoyY1   : Word;
  JoyX2   : Word;
  JoyY2   : Word;
  CJoyX   : Word;
  CJoyY   : Word;
  JoyX1_2 : Word;
  JoyY1_2 : Word;
  JoyX2_2 : Word;
  JoyY2_2 : Word;
  JoyB    : Byte;
  F       : File;
  Path    : String[79];
  _Menu   : DMenu;
  LPTMenu : DMenu;
  JoyMenu : DMenu;
  _Win    : DWindow;
  MWid    : Integer;
  St      : String;
  Code    : Integer;
  DJX,DJY : Word;
  Ports   : Word;
  Cont    : TController;

  Procedure Display;
  Var
    I,J : Integer;
    W   : PFileListType;
    St  : String;
    Row : Integer;
    Col : Integer;

    Procedure FastWrite(X,Y: Integer; Color: Byte; Var S: String);
    Var Addr: Word;
    Begin
      Addr := ((Y - 1) * MaxX + X - 1) * 2;
      Asm
        CLI
        CLD
        MOV   AX,0B800h
        MOV   ES,AX
        MOV   DI,WORD PTR Addr
        MOV   AH,BYTE PTR Color
        PUSH  DS
        LDS   SI,DWORD PTR S
        MOV   CL,BYTE PTR [SI]
        SUB   CH,CH
        INC   SI
@L1:
        LODSB
        STOSW
        LOOP  @L1
        POP   DS
        STI
      End; { Asm }
    End; { FastWrite }

    Procedure ShowPartial(Const St: String; Const X,Y: Integer);
    Var
      I   : Integer;
      St1 : String[1];

    Begin
      For I := 1 To Length(St) Do
      Begin
        St1 := St[I];
        If St1 <> ' ' Then FastWrite(X + I - 1,Y,TextAttr,St1);
      End; { For I }
    End; { ShowPartial }

  Begin
    I   := Rows * Cols;
    W   := Work1;
    Row := 1;
    Col := 1;
    While (W <> Nil) And (I <> 0) Do
    Begin
      If W = Work Then
      Begin
        TextColor(Black);
        TextBackGround(LightGray);
      End
      Else
      Begin
        Case W^.Size Of
2048,4096: TextColor(LightGray);
  8192: TextColor(White);
  8448: TextColor(LightRed);
 10495: TextColor(LightGreen);
 16384: TextColor(Yellow);
        Else
          TextColor(Black);
        End; { Case }
        If (W^.Size Mod 8448) = 0 Then TextColor(LightRed);
        TextBackGround(Blue);
      End;
      St := W^.Name;
      J  := Pos('.',St);
      If J <> 0 Then
       While J < 9 Do
       Begin
         Insert(' ',St,J);
         Inc(J);
       End; { While }
      While Length(St) < 16 Do St := St + ' ';
      FastWrite((Col - 1) * 16 + 1,Row + 1,TextAttr,St);
      Inc(Row);
      If (Row = Rows + 1) And (W^.Next <> Nil) And (I <> 1) Then
      Begin
        Row := 1;
        Inc(Col);
      End;
      Dec(I);
      W := W^.Next;
    End; { While }
    TextColor(LightGray);
    TextBackGround(Blue);
    While Row <= Rows Do
    Begin
      St := '                ';
      FastWrite((Col - 1) * 16 + 1,Row + 1,TextAttr,St);
      Inc(Row);
    End; { While }
    TextColor(Magenta);
    TextBackGround(LightGray);
    GotoXY(1,1);
    ClrEol;
    GotoXY(1,MaxY);
    ClrEol;

    St := 'PCAE ' + Version;
    FastWrite(2,1,TextAttr,St);

    TextColor(Black);

    St := Work^.Name;
    FastWrite(22,1,TextAttr,St);
    Str(Work^.Size,St);
    FastWrite(40,1,TextAttr,St);

    TextColor(Red);

    St := 'F1       F10       Esc     ';
    ShowPartial(St,52,1);
    TextColor(Black);
    St := '   Help      Menu      Quit';
    ShowPartial(St,52,1);

    Str(Num,St);
    St := St + ' Files';
    FastWrite(2,MaxY,TextAttr,St);
    St := '32In1 MeGaBoy Pitfall2 ParkBrs ActVsn MNetwork SupRchp TigrVsn';
    FastWrite(17,MaxY,TextAttr,St);

    TextColor(Red);

    St := '3       G            2 P       A      M           R    T      ';
    ShowPartial(St,17,MaxY);
  End; { Display }

  Procedure FindTop;
  Var I: Integer;
  Begin
    I     := Top;
    Work1 := Head;
    While (Work1 <> Nil) And (I > 0) Do
    Begin
      Work1 := Work1^.Next;
      Dec(I);
    End; { While }
  End;

  Procedure FindSel;
  Var I: Integer;
  Begin
    I     := Sel;
    Work  := Head;
    While (Work <> Nil) And (I > 0) Do
    Begin
      Work := Work^.Next;
      Dec(I);
    End; { While }
  End; { FindSel }

  Procedure _Up;
  Begin
    If Sel > 0 Then
    Begin
      If Sel = Top Then
      Begin
        Dec(Top);
        Work1 := Work^.Prev;
      End;
      Dec(Sel);
      Work := Work^.Prev;
      Show := True;
    End;
  End; { _Up }

  Procedure _Down;
  Begin
    If Sel < Num - 1 Then
    Begin
      If Sel = Top + Cols * Rows - 1 Then
      Begin
        Inc(Top);
        Work1 := Work1^.Next;
      End;
      Inc(Sel);
      Work := Work^.Next;
      Show := True;
    End;
  End; { _Down }

  Procedure _Left;
  Begin
    If Sel >= Rows Then
    Begin
      Show := True;
      Dec(Sel,Rows);
      If Sel < Top Then Dec(Top,Rows);
      If Top < 0 Then Top := 0;
      FindTop;
      FindSel;
    End;
  End; { _Left }

  Procedure _Right;
  Begin
    If Sel < Num - Rows Then
    Begin
      Show := True;
      Inc(Sel,Rows);
      If Sel >= Top + Cols * Rows Then Inc(Top,Rows);
      FindTop;
      FindSel;
    End;
  End; { _Right }

  Procedure Popup(St: String);
  Var
    W       : DWindow;
    I,J,X,Y : Integer;

  Begin
    TextColor(Black);
    TextBackground(LightGray);
    I := Length(St);
    X := (MaxX Div 2) - ((I + 4) Div 2);
    Y := MaxY Div 2;
    W.Init(X,Y - 2,X + I + 3,Y + 2,
           Black,LightGray,Black,LightGray,Black,LightGray,
           DoubleBorder,'',True);
    W.Display;
    GotoXY(2,2);
    Write(St);
    Sound(880);
    Delay(100);
    NoSound;
    Delay(10000);
    W.Done;
  End; { Popup }

  Procedure Popup4(St1,St2,St3,St4: String);
  Var
    W       : DWindow;
    I,J,X,Y : Integer;

  Begin
    TextColor(Black);
    TextBackground(LightGray);
    I := Length(St1);
    If I < Length(St2) Then I := Length(St2);
    If I < Length(St3) Then I := Length(St3);
    If I < Length(St4) Then I := Length(St4);
    X := (MaxX Div 2) - ((I + 4) Div 2);
    Y := MaxY Div 2;
    W.Init(X,Y - 2,X + I + 3,Y + 3,
           Black,LightGray,Black,LightGray,Black,LightGray,
           DoubleBorder,'',True);
    W.Display;
    GotoXY(2,1);
    Write(St1);
    GotoXY(2,2);
    Write(St2);
    GotoXY(2,3);
    Write(St3);
    GotoXY(2,4);
    Write(St4);
    Sound(880);
    Delay(100);
    NoSound;
    Delay(10000);
    W.Done;
  End; { Popup4 }

  Procedure StayPopup(St: String);
  Var I,J,X,Y : Integer;
  Begin
    TextColor(Black);
    TextBackground(LightGray);
    I := Length(St);
    X := (MaxX Div 2) - ((I + 4) Div 2);
    Y := MaxY Div 2;
    _Win.Init(X,Y - 2,X + I + 3,Y + 2,
              Black,LightGray,Black,LightGray,Black,LightGray,
              DoubleBorder,'',True);
    _Win.Display;
    GotoXY(2,2);
    Write(St);
  End; { StayPopup }

  Procedure NoJoysticks;
  Begin
    Config.UseJoystick1 := False;
    Config.UseJoystick2 := False;
    Assign(F,ConfigFile);
    ReWrite(F,1);
    BlockWrite(F,Config,SizeOf(Config));
    Close(F);
  End; { NoJoysticks }

  Procedure NoJoystick2;
  Begin
    Config.UseJoystick2 := False;
    Assign(F,ConfigFile);
    ReWrite(F,1);
    BlockWrite(F,Config,SizeOf(Config));
    Close(F);
  End; { NoJoystick2 }

Begin
  Controller := OldController;
  TextColor(LightGray);
  TextBackGround(Blue);
  ClrScr;

  { Locate all the .BIN and .PAL files }

  Head := Nil;
  Tail := Nil;
  Num  := 0;
  If ParamCount > 0 Then
  Begin
    Path := ParamStr(1);
    If (Path <> '') And Not (Path[Length(Path)] In [':','\']) Then Path := Path + '\';
  End
  Else Path := '';

  FindFirst(Path + '*.BIN',Archive,S);
  While DosError = 0 Do
  Begin
    If Head = Nil Then
    Begin
      New(Head);
      Tail := Head;
      Tail^.Prev := Nil;
    End
    Else
    Begin
      New(Tail^.Next);
      Tail^.Next^.Prev := Tail;
      Tail := Tail^.Next;
    End;
    Inc(Num);
    Tail^.Name := S.Name;
    Tail^.Size := S.Size;
    Tail^.Next := Nil;
    FindNext(S);
  End; { While }

  FindFirst(Path + '*.PAL',Archive,S);
  While DosError = 0 Do
  Begin
    If Head = Nil Then
    Begin
      New(Head);
      Tail := Head;
      Tail^.Prev := Nil;
    End
    Else
    Begin
      New(Tail^.Next);
      Tail^.Next^.Prev := Tail;
      Tail := Tail^.Next;
    End;
    Inc(Num);
    Tail^.Name := S.Name;
    Tail^.Size := S.Size;
    Tail^.Next := Nil;
    FindNext(S);
  End; { While }

  { Sort the list in ascending alphabetical order }

  Work := Head;
  While Work <> Nil Do
  Begin
    Work1 := Work^.Next;
    While Work1 <> Nil Do
    Begin
      If Work1^.Name < Work^.Name Then
      Begin
        Temp.Name   := Work1^.Name;
        Temp.Size   := Work1^.Size;
        Work1^.Name := Work^.Name;
        Work1^.Size := Work^.Size;
        Work^.Name  := Temp.Name;
        Work^.Size  := Temp.Size;
      End;
      Work1 := Work1^.Next;
    End; { Work1 }
    Work := Work^.Next;
  End; { While }

  { Main loop }

  If Head = Nil Then
  Begin
    Menu := '';
    Exit;
  End;
  FindTop;
  FindSel;
  MaxX  := Mem[$0:$44A];         { Max screen columns }
  MaxY  := Mem[$0:$484] + 1;     { Max screen rows    }
  If MaxY = 1 Then MaxY := 25;
  Cols  := MaxX Div 16;
  Rows  := MaxY - 2;
  Show  := True;

  Ports := 0;
  For I := 0 To 2 Do If MemW[0:$408 + I * 2] <> 0 Then Inc(Ports);

  _Menu.Init((MaxX Div 2) - 15,(MaxY Div 2) - 11,
             (MaxX Div 2) + 15,(MaxY Div 2) + 12,
             Black,LightGray,Black,LightGray,Black,LightGray,
             Red,LightGray,Black,Green,Red,Green,
             DarkGray,LightGray,DarkGray,Green,
             SingleBorder,' PCAE ' + Version + ' Main Menu ',True);
  _Menu.AddSelection(1, 1,29, 5,False,'Set frames per second');
  _Menu.AddSelection(1, 2,29, 7,False,'Build game profile');

  _Menu.AddSelection(1, 4,29,14,False,'Use standard controllers');
  _Menu.AddSelection(1, 5,29, 5,False,'Use paddle controllers');
  _Menu.AddSelection(1, 6,29, 8,False,'Use keyboard controllers');
  _Menu.AddSelection(1, 7,29, 5,False,'Use Indy 500 controllers');
  _Menu.AddSelection(1, 8,29, 5,False,'Use Video Touch Pad');

  _Menu.AddSelection(1,10,29,15,False,'Change paddle assignments');

  _Menu.AddSelection(1,12,29, 5,False,'Use keyboard');
  _Menu.AddSelection(1,13,29,19,False,'Calibrate and use joystick(s)');
  _Menu.AddSelection(1,14,29, 3,False,'Remap joystick buttons');
  If Ports > 0 Then
  Begin
    _Menu.AddSelection(1,16,29, 8,False,'Toggle using real controllers');
    _Menu.AddSelection(1,17,29, 7,False,'Set parallel port');
    _Menu.AddSelection(1,18,29, 3,False,'Calibrate paddles');
  End
  Else
  Begin
    _Menu.AddSelection(1,16,29, 8,True,'Toggle using real controllers');
    _Menu.AddSelection(1,17,29, 7,True,'Set parallel port');
    _Menu.AddSelection(1,18,29, 3,True,'Calibrate paddles');
  End;
  _Menu.AddSelection(1,19,29, 8,False,'Toggle debugger');
  _Menu.AddSelection(1,20,29, 8,False,'Toggle sound');
  _Menu.AddSelection(1,21,29,11,False,'Set sound options');
  _Menu.AddSelection(1,22,29, 9,False,'Toggle extended VGA mode');

  If Ports > 0 Then
  Begin
    LPTMenu.Init((MaxX Div 2) - 3,(MaxY Div 2) - 1,
                 (MaxX Div 2) + 3,(MaxY Div 2) + Ports,
                 Black,LightGray,Black,LightGray,Black,LightGray,
                 Red,LightGray,Black,Green,Red,Green,
                 DarkGray,LightGray,DarkGray,Green,
                 SingleBorder,'',True);
    For I := 0 To 2 Do
    Begin
      If MemW[0:$408 + I * 2] <> 0 Then
       LPTMenu.AddSelection(1,I + 1,5,5,False,HexWord(MemW[0:$408 + I * 2]));
    End; { For I }
  End;

  JoyMenu.Init((MaxX Div 2) - 20,(MaxY Div 2) - 2,
               (MaxX Div 2) + 20,(MaxY Div 2) + 3,
               Black,LightGray,Black,LightGray,Black,LightGray,
               Red,LightGray,Black,Green,Red,Green,
               DarkGray,LightGray,DarkGray,Green,
               SingleBorder,' <Enter> to change, <Esc> aborts ',True);
  JoyMenu.AddSelection(1,1,27,8,False,'Player 1 fire');
  JoyMenu.AddSelection(1,2,27,8,False,'Player 2 fire');
  JoyMenu.AddSelection(1,3,27,1,False,'Reset  / Booster-Grip btn 1');
  JoyMenu.AddSelection(1,4,27,1,False,'Select / Booster-Grip btn 2');
  JoyMenu.AddSelection(30,1,9,0,True,'Button ' + Chr(48 + ButtonNum[Config.Player1Fire]));
  JoyMenu.AddSelection(30,2,9,0,True,'Button ' + Chr(48 + ButtonNum[Config.Player2Fire]));
  JoyMenu.AddSelection(30,3,9,0,True,'Button ' + Chr(48 + ButtonNum[Config.JoystickReset]));
  JoyMenu.AddSelection(30,4,9,0,True,'Button ' + Chr(48 + ButtonNum[Config.JoystickSelect]));
  Repeat
    If Show Then
    Begin
      Display;
      Show := False;
    End;
    Ch := #0;
    If Config.UseJoystick1 And Not Config.UseRealControllers Then
    Begin
      JoyStatus(Config,JoyB,JoyX1,JoyY1,JoyX2,JoyY2);
      If JoyY1 < JoyMinY Then
      Begin
        _Up;
        Delay(300);
      End;
      If JoyY1 > JoyMaxY Then
      Begin
        _Down;
        Delay(300);
      End;
      If JoyX1 < JoyMinX Then
      Begin
        _Left;
        Delay(300);
      End;
      If JoyX1 > JoyMaxX Then
      Begin
        _Right;
        Delay(300);
      End;
      If (JoyB And 1) <> 0 Then
      Begin
        Ch := #13;

        { Wait until button is released }

        Repeat
          JoyStatus(Config,JoyB,JoyX1,JoyY1,JoyX2,JoyY2);
        Until (JoyB And 1) = 0;
      End;
    End;
    If KeyPressed Then
    Begin
      Ch := UpCase(ReadKey);
      If Ch = #0 Then
      Begin
        C := ReadKey;
        Case C Of
          #59: Begin                     { F1 }
                 MainMenuHelp;
                 Show := True;
               End;
          #68: Begin                     { F10 }
                 _Menu.Execute;
                 Case  _Menu.CurSel Of
                   1: Begin
                        _Win.Init(6,(MaxY Div 2) - 2,MaxX - 5,MaxY Div 2 + 2,
                        Black,LightGray,Black,LightGray,Black,LightGray,
                        DoubleBorder,'',True);
                        _Win.Display;
                        GotoXY(2,2);
                        Write('Enter frames-per-second limit (or 0 for no limit): ');
                        Str(Config.FrameRate,St);
                        St := _BufLen(53,2,St,Yellow,Blue,3,MaxX - 65);
                        _Win.Done;
                        Val(St,Config.FrameRate,Code);
                        If Config.FrameRate < 0 Then Config.FrameRate := 0;
                        Assign(F,ConfigFile);
                        ReWrite(F,1);
                        BlockWrite(F,Config,SizeOf(Config));
                        Close(F);
                        TextColor(LightGray);
                        TextBackGround(Blue);
                      End;
                   2: Begin
                        _Win.Init(6,(MaxY Div 2) - 5,MaxX - 5,MaxY Div 2 + 5,
                        Black,LightGray,Black,LightGray,Black,LightGray,
                        DoubleBorder,'',True);
                        _Win.Display;
                        GotoXY(7,2);
                        Write('Rebuilding PCAE.PRO cartridge profile file');
                        GotoXY(2,4);
                        MakeProfile(Path);
                        _Win.Done;
                      End;
                   3: Begin
                        Controller := crJoystick;
                        Popup('Using standard controllers');
                      End;
                   4: Begin
                        Controller := crPaddle;
                        Popup('Using paddle controllers');
                      End;
                   5: Begin
                        Controller := crKeyboard;
                        Popup('Keyboard controllers ACTIVE');
                      End;
                   6: Begin
                        Controller := crDriving;
                        Popup('Indy 500 controllers ACTIVE');
                      End;
                   7: Begin
                        Controller := crVTP;
                        Popup('Video Touch Pad ACTIVE');
                      End;
                   8: Begin
                        Config.MousePaddle := (Config.MousePaddle + 1) And 3;
                        Assign(F,ConfigFile);
                        ReWrite(F,1);
                        BlockWrite(F,Config,SizeOf(Config));
                        Close(F);
                        Str(Config.MousePaddle + 1,St);
                        Case Config.MousePaddle Of
                          0: Begin
                               Popup4('Paddle 0: mouse',
                                      'Paddle 1: joystick 1',
                                      'Paddle 2: joystick 2',
                                      'Paddle 3: N/A');
                             End;
                          1: Begin
                               Popup4('Paddle 0: joystick 1',
                                      'Paddle 1: mouse',
                                      'Paddle 2: joystick 2',
                                      'Paddle 3: N/A');
                             End;
                          2: Begin
                               Popup4('Paddle 0: joystick 1',
                                      'Paddle 1: joystick 2',
                                      'Paddle 2: mouse',
                                      'Paddle 3: N/A');
                             End;
                          3: Begin
                               Popup4('Paddle 0: joystick 1',
                                      'Paddle 1: joystick 2',
                                      'Paddle 2: N/A',
                                      'Paddle 3: mouse');
                             End;
                        End; { Case }
                      End;
                   9: Begin
                        Config.UseJoystick1 := False;
                        Config.UseJoystick2 := False;
                        Assign(F,ConfigFile);
                        ReWrite(F,1);
                        BlockWrite(F,Config,SizeOf(Config));
                        Close(F);
                        Popup('Switching to keyboard-only');
                      End;
                  10: Begin
                        StayPopup('Move joystick 1 to upper left and press any key, or <Esc> to exit:');
                        Repeat
                          JoyStatus(Config,JoyB,JoyX1,JoyY1,JoyX2,JoyY2);
                        Until KeyPressed;
                        C := ReadKey;
                        _Win.Done;
                        If C <> #27 Then
                        Begin
                          StayPopup('Center joystick 1 and press any key, or <Esc> to exit:');
                          Repeat
                            JoyStatus(Config,JoyB,CJoyX,CJoyY,JoyX2,JoyY2);
                          Until KeyPressed;
                          C := ReadKey;
                          _Win.Done;
                          If C <> #27 Then
                          Begin
                            StayPopup('Move joystick 1 to lower right and press any key, or <Esc> to exit:');
                            Repeat
                              JoyStatus(Config,JoyB,DJX,DJY,JoyX2,JoyY2);
                            Until KeyPressed;
                            C := ReadKey;
                            _Win.Done;
                            If C <> #27 Then
                            Begin
                              If (JoyX1 < JoyX2) And (JoyY1 < JoyY2) Then
                              Begin
                                Config.UseJoystick1 := True;
                                Config.MinJoyX      := JoyX1;
                                Config.MinJoyY      := JoyY1;
                                Config.MaxJoyX      := JoyX2;
                                Config.MaxJoyY      := JoyY2;
                                Config.JoyCenterX   := CJoyX;
                                Config.JoyCenterY   := CJoyY;
                                Assign(F,ConfigFile);
                                ReWrite(F,1);
                                BlockWrite(F,Config,SizeOf(Config));
                                Close(F);
                                JoyCenterX := CJoyX;
                                JoyCenterY := CJoyY;
                                JoyMinX    := (JoyCenterX + JoyX1) Div 2;
                                JoyMinY    := (JoyCenterY + JoyY1) Div 2;
                                JoyMaxX    := (JoyCenterX + JoyX2) Div 2;
                                JoyMaxY    := (JoyCenterY + JoyY2) Div 2;

                                StayPopup('Move joystick 2 to upper left and press any key, or <Esc> to exit:');
                                Repeat
                                  JoyStatus(Config,JoyB,DJX,DJY,JoyX1_2,JoyY1_2);
                                Until KeyPressed;
                                C := ReadKey;
                                _Win.Done;
                                If C <> #27 Then
                                Begin
                                  StayPopup('Center joystick 2 and press any key, or <Esc> to exit:');
                                  Repeat
                                    JoyStatus(Config,JoyB,DJX,DJY,CJoyX,CJoyY);
                                  Until KeyPressed;
                                  C := ReadKey;
                                  _Win.Done;
                                  If C <> #27 Then
                                  Begin
                                    StayPopup('Move joystick 2 to lower right and press any key, or <Esc> to exit:');
                                    Repeat
                                      JoyStatus(Config,JoyB,DJX,DJY,JoyX2_2,JoyY2_2);
                                    Until KeyPressed;
                                    C := ReadKey;
                                    _Win.Done;
                                    If C <> #27 Then
                                    Begin
                                      If (JoyX1_2 < JoyX2_2) And (JoyY1_2 < JoyY2_2) Then
                                      Begin
                                        Config.UseJoystick2 := True;
                                        Config.MinJoyX2     := JoyX1_2;
                                        Config.MinJoyY2     := JoyY1_2;
                                        Config.MaxJoyX2     := JoyX2_2;
                                        Config.MaxJoyY2     := JoyY2_2;
                                        Config.JoyCenterX2  := CJoyX;
                                        Config.JoyCenterY2  := CJoyY;
                                        Assign(F,ConfigFile);
                                        ReWrite(F,1);
                                        BlockWrite(F,Config,SizeOf(Config));
                                        Close(F);
                                        JoyCenterX2 := CJoyX;
                                        JoyCenterY2 := CJoyY;
                                        JoyMinX2    := (JoyCenterX2 + JoyX1_2) Div 2;
                                        JoyMinY2    := (JoyCenterY2 + JoyY1_2) Div 2;
                                        JoyMaxX2    := (JoyCenterX2 + JoyX2_2) Div 2;
                                        JoyMaxY2    := (JoyCenterY2 + JoyY2_2) Div 2;
                                      End
                                      Else
                                      Begin
                                        StayPopup('Error in calibration.  Press a key to return.');
                                        ReadKey;
                                        _Win.Done;
                                        Config.UseJoystick2 := False;
                                      End;
                                    End;
                                  End
                                  Else NoJoystick2;
                                End
                                Else NoJoystick2;
                              End
                              Else
                              Begin
                                StayPopup('Error in calibration.  Press a key to return.');
                                ReadKey;
                                _Win.Done;
                                NoJoysticks;
                              End;
                            End
                            Else NoJoysticks;
                          End
                          Else NoJoysticks;
                        End
                        Else NoJoysticks;
                        TextColor(LightGray);
                        TextBackGround(Blue);
                      End;
                  11: Begin
                        Repeat
                          JoyMenu.Execute;
                          If (JoyMenu.CurSel >= 1) And (JoyMenu.CurSel <= 4) Then
                          Begin
                            StayPopup('Press new joystick button or hit <Esc> to abort');
                            Repeat
                              JoyStatus(Config,JoyB,JoyX1,JoyY1,JoyX2,JoyY2);
                            Until (JoyB <> 0) Or KeyPressed;
                            While KeyPressed Do ReadKey;
                            _Win.Done;
                            If JoyB <> 0 Then
                            Begin
                              Case JoyMenu.CurSel Of
                                1: Begin
                                     Config.Player1Fire := ButtonBit[JoyB And $F];
                                     JoyMenu.GetSelection(5)^.SelStr := 'Button ' + Chr(48 + ButtonNum[JoyB And $F]);
                                   End;
                                2: Begin
                                     Config.Player2Fire := ButtonBit[JoyB And $F];
                                     JoyMenu.GetSelection(6)^.SelStr := 'Button ' + Chr(48 + ButtonNum[JoyB And $F]);
                                   End;
                                3: Begin
                                     Config.JoystickReset := ButtonBit[JoyB And $F];
                                     JoyMenu.GetSelection(7)^.SelStr := 'Button ' + Chr(48 + ButtonNum[JoyB And $F]);
                                   End;
                                4: Begin
                                     Config.JoystickSelect := ButtonBit[JoyB And $F];
                                     JoyMenu.GetSelection(8)^.SelStr := 'Button ' + Chr(48 + ButtonNum[JoyB And $F]);
                                   End;
                              End; { Case }
                              Assign(F,ConfigFile);
                              ReWrite(F,1);
                              BlockWrite(F,Config,SizeOf(Config));
                              Close(F);
                            End;
                          End;
                        Until JoyMenu.CurSel = 0;
                      End;
                  12: Begin
                        Config.UseRealControllers := Not Config.UseRealControllers;
                        Assign(F,ConfigFile);
                        ReWrite(F,1);
                        BlockWrite(F,Config,SizeOf(Config));
                        Close(F);
                        If Config.UseRealControllers
                         Then Popup('Using REAL controllers')
                         Else Popup('Using PC controllers');
                      End;
                  13: Begin
                        LPTMenu.Execute;
                        If (LPTMenu.CurSel >= 1) And (LPTMenu.CurSel <= Ports) Then
                         Config.LPT1Port := MemW[0:$408 + (LPTMenu.CurSel - 1) * 2];
                        Assign(F,ConfigFile);
                        ReWrite(F,1);
                        BlockWrite(F,Config,SizeOf(Config));
                        Close(F);
                      End;
                  14: Begin
                        StayPopup('Rotate paddle 1 to extreme left and press any key, or <Esc> to exit:');
                        Repeat
                          JoyStatus(Config,JoyB,JoyX1,JoyY1,JoyX2,JoyY2);
                        Until KeyPressed;
                        C := ReadKey;
                        _Win.Done;
                        If C <> #27 Then
                        Begin
                          Config.PaddleMax := JoyX1;
                          Assign(F,ConfigFile);
                          ReWrite(F,1);
                          BlockWrite(F,Config,SizeOf(Config));
                          Close(F);
                        End;
                        TextColor(LightGray);
                        TextBackGround(Blue);
                      End;
                  15: Begin
                        Debugger := Not Debugger;
                        If Debugger
                         Then Popup('Debugger is ON')
                         Else Popup('Debugger is OFF');
                      End;
                  16: Begin
                        Config.DoSound := Not Config.DoSound;
                        DoSound        := Config.DoSound;
                        Assign(F,ConfigFile);
                        ReWrite(F,1);
                        BlockWrite(F,Config,SizeOf(Config));
                        Close(F);
                        If DoSound
                         Then Popup('Sound is ON')
                         Else Popup('Sound is OFF');
                      End;
                  17: Begin
                        Handle.UnlockXM;
                        Handle.FreeXM;
                        DeAllocSound;
{                        FreeMem(SoundBuf[1],SoundBufSize);
                        FreeMem(SoundBuf[0],SoundBufSize * 2);}
                        _Win.Init(6,(MaxY Div 2) - 4,MaxX - 5,MaxY Div 2 + 4,
                        Black,LightGray,Black,LightGray,Black,LightGray,
                        DoubleBorder,'',True);
                        _Win.Display;
                        GotoXY(2,2);
                        Write('Sound buffer size adjustment');
                        GotoXY(2,3);
                        Write('(larger buffer sizes might give better sound quality,');
                        GotoXY(2,4);
                        Write('but require more processing power)');
                        GotoXY(2,6);
                        Write('Buffer size (256-10000): ');

                        Str(SoundBufSize,St);
                        St := _BufLen(26,6,St,Yellow,Blue,5,6);
                        Val(St,I,Code);
                        _Win.Done;

                        If (I >= 256) And (I <= 10000) Then
                        Begin
                          SoundBufSize := I And $FFFC;
                          Config.SoundBufSize := SoundBufSize;
                          Assign(F,ConfigFile);
                          ReWrite(F,1);
                          BlockWrite(F,Config,SizeOf(Config));
                          Close(F);
                        End
                        Else PopUp('Error: The entry must be a number in the range 256 to 10000');

                        _Win.Init(6,(MaxY Div 2) - 6,MaxX - 5,MaxY Div 2 + 6,
                         Black,LightGray,Black,LightGray,Black,LightGray,
                         DoubleBorder,'',True);
                        _Win.Display;
                        GotoXY(2,2);
                        Write('Sound playback rate adjustment');
                        GotoXY(2,3);
                        Write('(The largest value gives the best sound, but might not work on all sound cards)');
                        GotoXY(2,5);
                        Write('Playback rate: [',Playback_Freq,']: ');
                        GotoXY(2,6);
                        Write('  1.............11025 Hz');
                        GotoXY(2,7);
                        Write('  2.............15700 Hz');
                        GotoXY(2,8);
                        Write('  3.............22050 Hz');
                        GotoXY(2,9);
                        Write('  4.............31400 Hz');
                        GotoXY(2,11);
                        Write('Choice (1-4): ');
                        Repeat
                          C := ReadKey;
                        Until C In ['1'..'4'];
                        _Win.Done;
                        Case C Of
                          '1': Playback_Freq := 11025;
                          '2': Playback_Freq := 15700;
                          '3': Playback_Freq := 22050;
                          '4': Playback_Freq := 31400;
                        End; { Case }
                        Config.PlaybackRate := Playback_Freq;
                        Assign(F,ConfigFile);
                        ReWrite(F,1);
                        BlockWrite(F,Config,SizeOf(Config));
                        Close(F);

                        InitSound;
                        TextColor(LightGray);
                        TextBackGround(Blue);
                      End;
                {$IFDEF LOWRES}
                  18: Begin
                        If Config.MaxRows = 200 Then Config.MaxRows := 215 Else
                         If Config.MaxRows = 215 Then Config.MaxRows := 250 Else Config.MaxRows := 200;
                        If Config.MaxRows = 200 Then PopUp('Displaying 200 rows') Else
                         If Config.MaxRows = 215 Then PopUp('Displaying 215 rows') Else Popup('Displaying 250 rows');
                        Assign(F,ConfigFile);
                        ReWrite(F,1);
                        BlockWrite(F,Config,SizeOf(Config));
                        Close(F);
                      End;
                {$ELSE}
                  18: Begin
                        If Config.MaxRows = 200 Then Config.MaxRows := 204 Else Config.MaxRows := 200;
                        If Config.MaxRows = 200
                         Then PopUp('Displaying 200 rows')
                         Else PopUp('Displaying 204 rows');
                        Assign(F,ConfigFile);
                        ReWrite(F,1);
                        BlockWrite(F,Config,SizeOf(Config));
                        Close(F);
                      End;
                {$ENDIF}
                 End; { Case }
               End;
          #71: Begin                     { Home }
                 If Sel <> 0 Then Show := True;
                 Top   := 0;
                 Sel   := 0;
                 Work1 := Head;
                 Work  := Head;
               End;
          #72: _Up;                      { Up }
          #73: Begin                     { PgUp }
                 If Sel >= Cols * Rows Then
                 Begin
                   TextColor(LightGray);
                   TextBackGround(Blue);
                   ClrScr;
                   Show := True;
                   Dec(Sel,Cols * Rows);
                   Dec(Top,Cols * Rows);
                   If Top < 0 Then Top := 0;
                   FindTop;
                   FindSel;
                 End;
               End;
          #75: _Left;                    { Left }
          #77: _Right;                   { Right }
          #79: Begin                     { End }
                 If Sel <> Num - 1 Then Show := True;
                 Sel := Num - 1;
                 I   := Top;
                 Top := Sel - Cols * Rows + 1;
                 If Top < 0 Then Top := 0;
                 If I <> Top Then Show := True;
                 Work  := Tail;
                 FindTop;
               End;
          #80: _Down;                    { Down }
          #81: Begin                     { PgDn }
                 If Sel < Num - Cols * Rows Then
                 Begin
                   TextColor(LightGray);
                   TextBackGround(Blue);
                   ClrScr;
                   Show := True;
                   Inc(Sel,Cols * Rows);
                   Inc(Top,Cols * Rows);
                   FindTop;
                   FindSel;
                 End;
               End;
        End; { Case }
      End;
    End;
  Until Ch In [#13,#27,'A','G','R','P','M','T','2','3'];
  If Ch In [#13,'A','G','R','P','M','T','2','3'] Then
  Begin
    UseMenu := True;
    Menu    := Path + Work^.Name;
    If Ch = #13 Then
    Begin
      OldController := Controller;
      Ch := MenuKey[FindProfile(Work^.Name,Cont)];
      If Cont <> crUnknown Then Controller := Cont;
    End;
    Case Ch Of
'T': Begin                                { TigerVision }
      BankSwitch^[$003F] := $60;
      Cart              := ctTigerVision;
      BankSize          := 512;
    End;
'A': Begin                                { Robot Tank/Decathlon }
      BankSwitch^[$01FE] := 30;
      Cart              := ctActivision;
    End;
'2': Begin                                { Pitfall II }
      BankSwitch^[$1FF8] := $CB;
      BankSwitch^[$1FF9] := $CC;
      Cart               := ctPitfall2;
      FillChar(PF2ReadCount,SizeOf(PF2ReadCount),#0);
      For J := $1040 To $107F Do BankSwitch^[J] := $CF;
      For J := $1840 To $187F Do BankSwitch^[J] := $CF;
      For J := $1000 To $103F Do BankSwitch^[J] := $CE;
      For J := $1800 To $183F Do BankSwitch^[J] := $CE;
    End;
'R': Begin                                { Superchip }
      Cart := ctSuperChip;
{        BankSwitch^[$1FF6] := 1  + $40;
      BankSwitch^[$1FF7] := 5  + $40;
      BankSwitch^[$1FF8] := 9  + $40;
      BankSwitch^[$1FF9] := 13 + $40;}
      For J := $1000 To $107F Do BankSwitch^[J] := $5F;
      BankSize := 1024 - 64{32};    { Size in dwords }
    End;
'P': Begin                                { Parker Bros. }
      For J := $1FE0 To $1FF7 Do BankSwitch^[J] := J And $FF;
      Cart := ctParkerBros;
    End;
'M': Begin                                { M-Network }
      For J := $1FE0 To $1FEB Do BankSwitch^[J] := (J And $FF) - $10;
      For J := $1000 To $13FF Do BankSwitch^[J] := $DC;
      For J := $1800 To $18FF Do BankSwitch^[J] := $DD;
      Cart := ctMNetwork;
      MNetworkRAM := 8;
    End;
'G': Begin                               { 16-in-1 MegaBoy }
      BankSwitch^[$1FF0] := $80;
      Cart := ctMegaBoy;
    End;
'3': Begin                               { 32-in-1 }
{      BankSwitch^[$1FF0] := $80;}
      Cart := ct32In1;
      _Win.Init(6,(MaxY Div 2) - 2,MaxX - 5,MaxY Div 2 + 2,
       Black,LightGray,Black,LightGray,Black,LightGray,
       DoubleBorder,'',True);
      _Win.Display;
      GotoXY(2,2);
      Write('Enter game number to play (0-31):');
      Str(MegaBoyNum,St);
      St := _BufLen(34,2,St,Yellow,Blue,3,3);
      Val(St,J,Code);
      If (J >= 0) And (J <= 31) Then MegaBoyNum := J;
      _Win.Done;
    End;
    Else
      Cart := ct4k;
      If Work^.Size = 8192 Then          { Standard 8k }
      Begin
        BankSwitch^[$1FF8] := 1;
        BankSwitch^[$1FF9] := 5;
        Cart := ct8k;
      End;
      If Work^.Size = 10495 Then         { Pitfall II }
      Begin
        BankSwitch^[$1FF8] := $CB;
        BankSwitch^[$1FF9] := $CC;
        Cart               := ctPitfall2;
        FillChar(PF2ReadCount,SizeOf(PF2ReadCount),#0);
        For J := $1040 To $107F Do BankSwitch^[J] := $CF;
        For J := $1840 To $187F Do BankSwitch^[J] := $CF;
        For J := $1000 To $103F Do BankSwitch^[J] := $CE;
        For J := $1800 To $183F Do BankSwitch^[J] := $CE;
      End;
      If (Work^.Size Mod 8448) = 0 Then          { Starpath }
      Begin
        For J := $1000 To $1FFF Do BankSwitch^[J] := $70;
        BankSwitch^[$1FF8] := $70;
        BankSwitch^[$0E00] := $70;
        Cart := ctStarpath;
      End;
      If Work^.Size = 12288 Then         { CBS RAM-Plus }
      Begin
        BankSwitch^[$1FF8] := $21;
        BankSwitch^[$1FF9] := $25;
        BankSwitch^[$1FFA] := $29;
        For J := $1000 To $10FF Do BankSwitch^[J] := $30;
        BankSize := 1024 - 128{64};    { Size in dwords }
        Cart := ctCBS;
      End;
      If Work^.Size = 16384 Then         { Standard 16k }
      Begin
        BankSwitch^[$1FF6] := 1;
        BankSwitch^[$1FF7] := 5;
        BankSwitch^[$1FF8] := 9;
        BankSwitch^[$1FF9] := 13;
        Cart := ct16k;
      End;
    End; { Case }
  End
  Else
  Begin
    Menu    := '';
    UseMenu := False;
  End;

  { Kill the file list }

  Work := Head;
  While Work <> Nil Do
  Begin
    Work1 := Work^.Next;
    Dispose(Work);
    Work := Work1;
  End; { While }
  TextColor(LightGray);
  TextBackGround(Black);
  ClrScr;
  If Ports > 0 Then LPTMenu.Done;
  _Menu.Done;
  JoyMenu.Done;
End; { Menu }

Begin
  OldController := crJoystick;
End.